package com.joelhelkala.watcherGui.frames.panels;

import java.awt.Dimension;

import javax.swing.JPanel;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.plot.CategoryPlot;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.data.category.DefaultCategoryDataset;

import com.joelhelkala.watcherGui.Node.NodeData.NodeData;

import java.awt.BorderLayout;
import java.util.List;

public class LineChartPanel extends JPanel {
	
	private JFreeChart lineChart;
	private ChartPanel chartPanel;
	private CategoryPlot plot;
	
	// Constructor
	public LineChartPanel(String chartTitle, List<NodeData> list) {
		lineChart = ChartFactory.createLineChart(chartTitle, "DateTime","Temperature",
		         createDataset(list),
		         PlotOrientation.VERTICAL,
		         true,true,false);
		
		chartPanel = new ChartPanel( lineChart );
	    chartPanel.setPreferredSize( new Dimension( 560 , 367 ) );
	    plot = (CategoryPlot) lineChart.getPlot();
	    
	    this.setLayout(new BorderLayout());
	    this.add(chartPanel, BorderLayout.CENTER);
	    this.validate();
	}
	
	// Create dataset from given nodedata list
	private DefaultCategoryDataset createDataset(List<NodeData> list) {
		DefaultCategoryDataset dataset = new DefaultCategoryDataset( );
		list.sort((a,b) -> a.getTime().compareTo(b.getTime()));
		
		for(NodeData data : list) {
			dataset.addValue(data.getTemperature(), "temp", data.getTime());
		}
		
		return dataset;
	}

	// Update chart data
	public void updateData(List<NodeData> list) {
		plot.setDataset(createDataset(list));
	}
}
